package com.realnet.task.Controllers;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import com.fasterxml.jackson.core.JsonProcessingException;
import org.springframework.web.bind.annotation.CrossOrigin;
import com.fasterxml.jackson.databind.JsonMappingException;
import com.realnet.config.EmailService;
import com.realnet.users.entity1.AppUser;
import com.realnet.users.service1.AppUserServiceImpl;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.data.domain.*;
import com.realnet.fnd.response.EntityResponse;
import org.springframework.http.*;
import org.springframework.beans.factory.annotation.*;
import com.realnet.task.Entity.Task;
import com.realnet.task.Services.TaskService ;






@RequestMapping(value = "/token/Task")
 @CrossOrigin("*") 
@RestController
public class tokenFree_TaskController {
	@Autowired
	private TaskService Service;

@Value("${projectPath}")
	private String projectPath;
 






	@PostMapping("/Task")
		  public Task Savedata(@RequestBody Task data) {
		Task save = Service.Savedata(data)	;





		System.out.println("data saved..." + save);

 return save;
	  }
@PutMapping("/Task/{id}")
	public  Task update(@RequestBody Task data,@PathVariable Integer id ) {
		Task update = Service.update(data,id);
		System.out.println("data update..." + update);
		return update;
	}	 
//	get all with pagination
	@GetMapping("/Task/getall/page")
	public Page<Task> getall(@RequestParam(value = "page", required = false) Integer page,
			@RequestParam(value = "size", required = false) Integer size) {
		Pageable paging = PageRequest.of(page, size);
		Page<Task> get = Service.getAllWithPagination(paging);

		return get;

	}	
	@GetMapping("/Task")
	public List<Task> getdetails() {
		 List<Task> get = Service.getdetails();		
		return get;
}
// get all without authentication 

	@GetMapping("/token/Task")
	public List<Task> getallwioutsec() {
		 List<Task> get = Service.getdetails();		
		return get;
}
@GetMapping("/Task/{id}")
	public  Task  getdetailsbyId(@PathVariable Integer id ) {
		Task  get = Service.getdetailsbyId(id);
		return get;
	}
@DeleteMapping("/Task/{id}")
	public  ResponseEntity<?> delete_by_id(@PathVariable Integer id ) {
	Service.delete_by_id(id);
			return new ResponseEntity<>(new EntityResponse("Deleted"), HttpStatus.OK);
	
	}







}